/*****<<<<< prterr.c - Ver 1.21 - L. Rayburn - 5 July 1987 -  a companion 
program to famcheck.c which detects logical errors in data files created by 
PAF Ver. 2.  prterr.c provides header and prints the error file created by
famcheck.com  >>>>>*****/

#include "stdio.h"              
#include "stdlib.h"               /* register union see famcheck.doc */

main()
{
   void header();
   int linecount=0;
   FILE *cfp, *fp, *ofp;
   char line[81],infile[33];
   unsigned pagecount =0;

      printf("PRTERR - - Version 1.21 - - L. M. Rayburn   JUL 1987");
      if((ofp = fopen("prn", "w")) == NULL)
      {
         printf("Printer not ready!\n");
         exit(-1);
      }

      if((cfp = fopen("famcheck.cfg", "r")) == NULL)
      {
         printf("ERROR! Unable to open config file.\n");
         exit(-1);
      }
      fgets(infile,32,cfp);
      fgets(infile,32,cfp);                 /* discard first 3 lines */
      fgets(infile,32,cfp);
      fgets(infile,32,cfp);                /* find location of errmsg */
      infile[strlen(infile)-1] = '\0';     /* discard the carriage return */

      if((fp = fopen(infile, "r")) == NULL)  /*  open errmsg.d file  */
      {
         printf("ERROR! Unable to open error message file. (errmsg.d)\n");
         exit(-1);
      }

      header(++pagecount,ofp);          /* make a header for the first page */
      while(fgets(line,81,fp))          /* get a line from the errmsg file */
      {
         fprintf(ofp,"%s",line);        /* print the line on the printer */
         if(++linecount % 51 == 0)      /* if page is full     */
         {
            header(++pagecount,ofp);    /* then formfeed and make new header */
            linecount = 0;              /* reset the linecount on new page */
         }
      }                                 /* LOOP to get another line and print */

      fprintf(ofp,"\f");                    /*  all done! eject paper, close */
      exit(0);                          /*  files and exit print routine */
}

/*****<<<<< end of main  >>>>>*****/

/*****<<<<<  header function >>>>>*****/

int header(pagecount,ofp)
unsigned pagecount;
FILE *ofp;

{
   void sysdate();

   if(pagecount >1)
      fprintf(ofp,"\f");
   
   fprintf(ofp,"\n\n\n\n\n");
   sysdate(ofp);
   fprintf(ofp,"%20sFamily Records Check\n\n","");
   fprintf(ofp,"MRIN  RIN  RIN    Description of Potential Error.%24sPage %d\n",
      "",pagecount);
   fprintf(ofp,"================================================================================\n");

   return(0);
}

/*****<<<<< end of header function  >>>>>*****/
/***** retrieve date with bdosx *****/

void sysdate(ofp)
FILE *ofp;
{
   REGS reg;
   long date, year;
   char month, day;

   bdosx(0x2a, &reg);
   year = reg.word.cx;
   month = reg.byte.dh;
   day = reg.byte.dl; 
   fprintf(ofp,"%u-%u-%lu",month, day, year);
}
/***** < < < end of prterr.c > > > *****/

